Index: /trunk/include/slib.h
===================================================================
--- /trunk/include/slib.h	(revision 584)
+++ /trunk/include/slib.h	(revision 1)
@@ -24,6 +24,4 @@
 #endif
 
-#include "sh_string.h"
-
 /****************
 
@@ -40,5 +38,4 @@
 *****************/
 
-
 /* --------------------------------------------------------------
  * 
@@ -60,20 +57,8 @@
  * TRUE, FALSE
  */
-#if !defined(S_TRUE)
-#define S_TRUE  1
-#define S_FALSE 0
-#endif
-
-#define SH_GRBUF_SIZE   4096
-#define SH_PWBUF_SIZE  32768
-
-
-#if defined(__GNUC__) && (__GNUC__ >= 3)
-#undef  SL_GNUC_CONST
-#define SL_GNUC_CONST   __attribute__((const))
-#else
-#undef  SL_GNUC_CONST
-#define SL_GNUC_CONST
-#endif
+#define SL_TRUE  1
+#define SL_FALSE 0
+
+
 
 /*
@@ -108,9 +93,7 @@
 #define SL_EWRITE    -1037     /* Write error. Check errno.            */
 #define SL_ESYNC     -1038     /* Write error. Check errno.            */
-#define SL_ECLOSE    -1039     /* Close error. Check errno.            */
 
 #define SL_EBADNAME  -1040     /* Invalid name.                        */
 #define SL_ESTAT     -1041     /* stat of file failed. Check errno.    */
-#define SL_EFSTAT    -1042     /* fstat of file failed. Check errno.   */
 
 #define SL_EBADUID   -1050	/* Owner not trustworthy.              */
@@ -120,20 +103,4 @@
 #define SL_TOOMANY   -1053      /* Too many open files                 */
 #define SL_TIMEOUT   -1054      /* Timeout in read                     */
-
-#define SL_EISDIR    -1055      /* Is a directory                      */
-
-#define SL_EINTERNAL01 -1061    /* Internal error.                      */
-#define SL_EINTERNAL02 -1062    /* Internal error.                      */
-#define SL_EINTERNAL03 -1063    /* Internal error.                      */
-#define SL_EINTERNAL04 -1064    /* Internal error.                      */
-#define SL_EINTERNAL05 -1065    /* Internal error.                      */
-#define SL_EINTERNAL06 -1066    /* Internal error.                      */
-#define SL_EINTERNAL07 -1067    /* Internal error.                      */
-#define SL_EINTERNAL08 -1068    /* Internal error.                      */
-#define SL_EINTERNAL09 -1069    /* Internal error.                      */
-#define SL_EINTERNAL10 -1070    /* Internal error.                      */
-#define SL_EINTERNAL11 -1071    /* Internal error.                      */
-#define SL_EINTERNAL12 -1072    /* Internal error.                      */
-
 /*
  * All int functions return SL_NONE on success.
@@ -144,7 +111,7 @@
 #endif
 
-  int dlog (int flag, const char * file, int line, const char *fmt, ...);
-
-  char * sl_get_errmsg(void);
+  int dlog (int flag, char * file, int line, const char *fmt, ...);
+
+  char * sl_get_errmsg();
 
   /* ---------------------------------------------------------------- 
@@ -154,5 +121,5 @@
    * ---------------------------------------------------------------- */
 
-  int sl_test_heap(void);
+  int sl_test_heap();
 
   /* ---------------------------------------------------------------- 
@@ -164,9 +131,9 @@
   extern int sl_useCaps;
 
-  int sl_drop_cap (void);
-  int sl_drop_cap_sub(void);
-  int sl_get_cap_sub(void);
-  int sl_drop_cap_qdel(void);
-  int sl_get_cap_qdel(void);
+  int sl_drop_cap ();
+  int sl_drop_cap_sub();
+  int sl_get_cap_sub();
+  int sl_drop_cap_qdel();
+  int sl_get_cap_qdel();
 
   /* ---------------------------------------------------------------- 
@@ -180,8 +147,6 @@
    */
   void *sl_memset(void *s, int c, size_t n);
-#if !defined(SH_REAL_SET)
 #undef  memset
 #define memset sl_memset
-#endif
 
   /* 
@@ -224,10 +189,7 @@
 
   /*
-   * robust strn[case]cmp replacement
+   * robust strncmp replacement
    */
   int sl_strncmp(const char * a, const char * b, size_t n);
-  int sl_ts_strncmp(const char * a, const char * b, size_t n);
-
-  int sl_strncasecmp(const char * a, const char * b, size_t n);
 
   /*
@@ -235,9 +197,4 @@
    */
   int sl_strcmp(const char * a, const char * b);
-
-  /*
-   * robust strcasecmp replacement
-   */
-  int sl_strcasecmp(const char * one, const char * two);
 
   /*
@@ -257,5 +214,5 @@
    * UID HANDLING FUNCTIONS.
    */
-  int sl_policy_get_user(const char *username);  /* drop SUID to <username>  */ 
+  int sl_policy_get_user(char *username);  /* drop SUID to <username>  */ 
   int sl_policy_get_real(char *username);  /* drop privs to <username> */
   int sl_policy_get_root(void);            /* drop SUID to root        */
@@ -274,5 +231,5 @@
    */
   int sl_get_euid(/*@out@*/uid_t * ret);
-  uid_t sl_ret_euid(void);
+  uid_t sl_ret_euid();
 
   /*
@@ -334,80 +291,37 @@
    * ---------------------------------------------------------------- */
 
-#define SL_OFILE_SIZE 32
-
-  char * sl_check_badfd();
-  char * sl_check_stale();
-
-  /* Create a file record for an open file
-   */
-  SL_TICKET sl_make_ticket (const char * ofile, int oline,
-			    int fd, const char * filename, FILE * stream);
- 
-  /* Get the pointer to a stream. If none exists yet, open it
-   */
-  FILE * sl_stream (SL_TICKET ticket, char * mode);
+  SL_TICKET sl_make_ticket (int fd, char * path);
 
   /* Open for writing.
    */
-  SL_TICKET  sl_open_write       (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
+  SL_TICKET  sl_open_write       (char * fname, int priviledge_mode);
 
   /* Open for reading.
    */
-  SL_TICKET  sl_open_read        (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
-
-  /* Drop from cach when closing
-   */
-  int sl_set_drop_cache(const char * str);
+  SL_TICKET  sl_open_read        (char * fname, int priviledge_mode);
 
   /* Open for reading w/minimum checking.
    */
-  SL_TICKET  sl_open_fastread    (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
+  SL_TICKET  sl_open_fastread    (char * fname, int priviledge_mode);
 
   /* Open for read and write.
    */
-  SL_TICKET  sl_open_rdwr        (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
+  SL_TICKET  sl_open_rdwr        (char * fname, int priviledge_mode);
 
   /* Open for read and write, fail if file exists.
    */
-  SL_TICKET sl_open_safe_rdwr    (const char * ofile, int oline,
-				  const char * fname, int priv);
+  SL_TICKET sl_open_safe_rdwr    (char * fname, int priv);
 
   /* Open for write, truncate.
    */
-  SL_TICKET  sl_open_write_trunc (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
+  SL_TICKET  sl_open_write_trunc (char * fname, int priviledge_mode);
 
   /* Open for read and write, truncate.
    */
-  SL_TICKET  sl_open_rdwr_trunc  (const char * ofile, int oline,
-				  const char * fname, int priviledge_mode);
-
-  /* Initialize the content sh_string.
-   */
-  int sl_init_content (SL_TICKET ticket, size_t size);
-
-  /* Get the (pointer to) the content sh_string.
-   */
-  sh_string * sl_get_content (SL_TICKET ticket);
-
-  /* Lock file (uses fcntl F_SETLK).
-   */
-  int sl_lock (SL_TICKET ticket);
+  SL_TICKET  sl_open_rdwr_trunc  (char * fname, int priviledge_mode);
 
   /* Close file.
    */
   int sl_close (SL_TICKET ticket);
-
-  /* Close file descriptor.
-   */
-  int sl_close_fd (const char * file, int line, int fd);
-
-  /* Close stream.
-   */
-  int sl_fclose (const char * file, int line, FILE * fp);
 
   /* Unlink file.
@@ -435,14 +349,6 @@
   int sl_read (SL_TICKET ticket, void * buf, size_t count);
 
-  int sl_read_timeout_prep (SL_TICKET ticket);
-
-  int sl_read_timeout_fd (int fd, void * buf, 
-			  size_t count, int timeout, int is_nonblocking);
-
-  int sl_read_timeout_fd_once (int fd, void * buf, 
-			       size_t count, int timeout, int is_nonblocking);
-
   int sl_read_timeout (SL_TICKET ticket, void * buf, 
-		       size_t count, int timeout, int is_nonblocking);
+		       size_t count, int timeout);
 
   int sl_read_fast (SL_TICKET ticket, void * buf_in, size_t count);
@@ -450,30 +356,25 @@
   /* Write file.
    */
-  int sl_write (SL_TICKET ticket, const void * msg, long nbytes);
+  int sl_write (SL_TICKET ticket, void * msg, long nbytes);
 
   /* Write file, terminate with newline.
    */
-  int sl_write_line (SL_TICKET ticket, const void * msg, long nbytes);
-
-  /* As above, but only for non-constant strings.
-   */
-  int sl_write_line_fast (SL_TICKET ticket, void * msg, long nbytes);
+  int sl_write_line (SL_TICKET ticket, void * msg, long nbytes);
 
   /* Drop all metadata for file descriptors >= fd.
    */
   int sl_dropall(int fd, int except);
-  int sl_dropall_dirty(int fd, int except); /* don't deallocate */
 
   /* Check whether file is trustworthy.
    */
-  int sl_trustfile(const char * path, uid_t * ok, uid_t * bad);
+  int sl_trustfile(char * path, uid_t * ok, uid_t * bad);
 
   /* Check whether file is trustworthy.
    */
-  int sl_trustfile_euid(const char * filename, uid_t euid);
+  int sl_trustfile_euid(char * filename, uid_t euid);
 
   /* purge list of trusted users
    */
-  int  sl_trust_purge_user (void);
+  int  sl_trust_purge_user ();
 
   /* Add a trusted user.
@@ -488,14 +389,4 @@
    */
   char * sl_trust_errfile(void);
-
-  /* Overflow tests
-   */
-  int sl_ok_muli (int a, int b) SL_GNUC_CONST;
-  int sl_ok_divi (int a, int b) SL_GNUC_CONST;
-  int sl_ok_addi (int a, int b) SL_GNUC_CONST;
-  int sl_ok_subi (int a, int b) SL_GNUC_CONST;
-
-  int sl_ok_muls (size_t a, size_t b) SL_GNUC_CONST;
-  int sl_ok_adds (size_t a, size_t b) SL_GNUC_CONST;
 
 
@@ -509,7 +400,5 @@
 #define SL_NOPRIV  0x34
 
-/* Suitable for Linux
- */
-#define MAXFILENAME	4096
+#define MAXFILENAME	2048
 
 
@@ -533,5 +422,5 @@
     /*@i@*/ if (assertion) ;                           \
     else {                                             \
-        dlog(0, FIL__, __LINE__, _("FAILED: file=<%s>, line=<%d>, assertion=<%s>\n"),            \
+        dlog(0, FIL__, __LINE__, SDG_AFAIL,            \
                  FIL__, __LINE__, astext);             \
         _exit(EXIT_FAILURE);                           \
@@ -603,10 +492,10 @@
 void sl_stack_push(char * c, char * file, int line);
 void sl_stack_pop(char * c, char * file, int line);
-void sl_stack_print(void);
+void sl_stack_print();
 #endif
-void sl_trace_in   (const char * str, const char * file, int line);
-void sl_trace_out  (const char * str, const char * file, int line);
-int  sl_trace_file (const char * str);
-int  sl_trace_use  (const char * str);
+void sl_trace_in   (char * str, char * file, int line);
+void sl_trace_out  (char * str, char * file, int line);
+int  sl_trace_file (char * str);
+int  sl_trace_use  (char * str);
 
 
@@ -621,5 +510,5 @@
 do {                                                                \
    if((long)(x) < 0) {                                              \
-      TPT((0,    FIL__, __LINE__, _("error=<%ld>.\n"), (long)(x)))            \
+      TPT((0,    FIL__, __LINE__, SDG_ERROR, (long)(x)))            \
       sl_errno=(x);                                                 \
     }                                                               \
Index: /trunk/include/zAVLTree.h
===================================================================
--- /trunk/include/zAVLTree.h	(revision 584)
+++ /trunk/include/zAVLTree.h	(revision 1)
@@ -33,11 +33,8 @@
 
 /* typedef the keytype */
-typedef const void * zAVLKey;
+typedef const char * zAVLKey;
 
 /* Comparison function for strings is strcmp(). */
-/* #define zAVLKey_cmp(tree, a, b) (strcmp((a), (b))) */
-
-#define zAVL_KEY_STRING 0
-#define zAVL_KEY_INT    1
+#define zAVLKey_cmp(tree, a, b) (strcmp((a), (b)))
 
 
@@ -56,5 +53,4 @@
   long count;
   zAVLKey (*getkey)(const void *item);
-  int keytype;
 } zAVLTree;
 
@@ -66,5 +62,5 @@
 
 
-extern zAVLTree *zAVLAllocTree (zAVLKey (*getkey)(void const *item), int keytype);
+extern zAVLTree *zAVLAllocTree (zAVLKey (*getkey)(void const *item));
 extern void zAVLFreeTree (zAVLTree *avltree, void (freeitem)(void *item));
 extern int zAVLInsert (zAVLTree *avltree, void *item);
@@ -74,9 +70,3 @@
 extern void *zAVLNext (zAVLCursor *avlcursor);
 
-extern char * zAVL_string_get (zAVLTree * tree, const char * key);
-/* uses strdup to insert a copy */
-extern int zAVL_string_set (zAVLTree ** tree, const char * key); 
-extern void zAVL_string_reset (zAVLTree * tree);
-extern void zAVL_string_del (zAVLTree * tree, const char * key);
-
 #endif
Index: /trunk/init/samhain.startFreeBSD.in
===================================================================
--- /trunk/init/samhain.startFreeBSD.in	(revision 584)
+++ /trunk/init/samhain.startFreeBSD.in	(revision 1)
@@ -1,44 +1,95 @@
-#!/bin/sh
+#! /bin/sh -
+#
+#    initialization/shutdown script for @install_name@ package
 
-# PROVIDE: @install_name@
-# REQUIRE: LOGIN
-# KEYWORD: shutdown
+prefix="@prefix@"
+exec_prefix="@exec_prefix@"
 
-. /etc/rc.subr
+PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+DAEMON=@sbindir@/@install_name@
+NAME=@install_name@
+pidfile=@mylockfile@
 
-name="@install_name@"
-rcvar=`set_rcvar`
+test -f $DAEMON || exit 0
 
-pidfile="@mylockfile@"
-
-# there are no required_files in general,
-# as they might be downloaded from the server
-#
-# required_files="@myconffile@ @mydatafile@"
-
-extra_commands="reload"
-stop_postcmd="remove_stale_files"
-
-command="@sbindir@/@install_name@"
-
-is_set()
-{
-    eval "[ -n \"\${$1+X}\" ]"
+safe_pidof () {
+    pidval=0
+    if [ -f $pidfile ] ; then
+       pidval=`cat $pidfile | awk '{ print $1 }'`
+       echo "${pidval}" | grep ['[^0123456789]'] >/dev/null 2>&1 && pidval=0
+    fi
+    echo $pidval
+    if [ x"$pidval" = x0 ] ; then
+	return 1
+    else
+	return 0
+    fi
 }
 
-remove_stale_files()
-{
-    if test -f @mylockfile@; then
-	/bin/rm -f @mylockfile@
-    fi
-    /bin/rm -f @mylockdir@/${name}.sock
+log_stat_msg () {
+case "$1" in
+	0)
+	echo "Service $NAME: Running";
+	break;
+	;;
+	1)
+	echo "Service $NAME: Stopped and @mylockfile@ pid file exists";
+	break;
+	;;
+	3)
+	echo "Service $NAME: Stopped";
+	break;
+	;;
+	*)
+	echo "Service $NAME: Status unknown";
+	break;
+	;;
+esac
 }
 
-load_rc_config "$name"
+case "$1" in
+  start)
+	#
+	# Remove a stale lockfile, if found
+	#
+	if test -f @mylockfile@; then
+	    rm -f @mylockfile@
+	fi
+        /bin/rm -f @mylockdir@/${NAME}.sock
+        $DAEMON -D && echo -n " $NAME"
+        ;;
+  stop)
+        PID=`safe_pidof`
+	if test "x$PID" != x0
+	then
+		kill $PID && echo -n " $NAME"
+        fi
+        ;;
+  reload|force-reload)
+        PID=`safe_pidof`
+        if test "x$PID" != x0
+        then
+		echo " Reloading $NAME configuration file."
+                kill -s HUP $PID && echo -n " $NAME"
+	else
+		echo " Cannot determine PID of process $NAME."
+		exit 1
+        fi
+        ;;
+  restart)
+	$0 stop
+        sleep 3
+        $0 start
+        ;;
+    status)
+        $DAEMON  status
+	ERRNUM=$?
+	log_stat_msg ${ERRNUM}
+	exit ${ERRNUM}
+        ;;
+  *)
+        echo " Usage: $0 {start|stop|restart|reload|force-reload}" >&2
+        exit 1
+        ;;
+esac
 
-if ! is_set ${rcvar}; then 
-    eval "${rcvar}=YES"
-fi
-
-run_rc_command "$1"
-
Index: /trunk/init/samhain.startGentoo.in
===================================================================
--- /trunk/init/samhain.startGentoo.in	(revision 584)
+++ /trunk/init/samhain.startGentoo.in	(revision 1)
@@ -11,4 +11,5 @@
 	/sbin/start-stop-daemon --start --quiet  --exec @sbindir@/@install_name@
 	eend $?
+	@sh_insmod_cmd@
 }
 
Index: /trunk/init/samhain.startLSB.in
===================================================================
--- /trunk/init/samhain.startLSB.in	(revision 584)
+++ /trunk/init/samhain.startLSB.in	(revision 1)
@@ -3,6 +3,6 @@
 ### BEGIN INIT INFO
 # Provides: @install_name@
-# Required-Start: $syslog $network $remote_fs
-# Required-Stop: $syslog $network $remote_fs
+# Required-Start: $syslog $network
+# Required-Stop: $syslog $network
 # Default-Start: 2 3 4 5
 # Default-Stop: 0 1 6
Index: /trunk/init/samhain.startLinux.in
===================================================================
--- /trunk/init/samhain.startLinux.in	(revision 584)
+++ /trunk/init/samhain.startLinux.in	(revision 1)
@@ -1,4 +1,3 @@
 #!/bin/bash
-
 # chkconfig: 2345 99 10
 # description: File Integrity Checking Daemon
@@ -10,14 +9,4 @@
 #
 
-### BEGIN INIT INFO
-# Provides: @install_name@
-# Required-Start: $syslog $network $remote_fs
-# Required-Stop: $syslog $network $remote_fs
-# Default-Start: 2 3 4 5
-# Default-Stop: 0 1 6
-# Short-Description: Keep an eye on stuff
-# Description: Keep an eye on stuff
-### END INIT INFO
-
 # For Debian
 #
@@ -40,13 +29,6 @@
 # and the command to run them.
 if [ -f /etc/redhat-release ]; then
-    if [ -f /etc/init.d/functions ]; then
 	. /etc/init.d/functions
 	DISTRO=redhat
-    elif [ -f /etc/rc.d/init.d/functions ]; then
-	. /etc/rc.d/init.d/functions
-	DISTRO=redhat
-    else
-	DISTRO=generic
-    fi
 elif [ -f /etc/mandrake-release ]; then
 	. /etc/init.d/functions
@@ -81,5 +63,5 @@
 fi
 
-debian_end()
+function debian_end ()
 {
 	if [ $RETVAL -eq 0 ];
@@ -121,5 +103,5 @@
 
 # echo OK in green if is success, FAILED in red is failed
-generic_end()
+function generic_end ()
 {
 	if [ $RETVAL -eq 0 ];
@@ -161,18 +143,11 @@
 	debian)
 		echo -n "Starting ${NAME}"
-		( /sbin/start-stop-daemon --start --oknodo --quiet --exec $DAEMON )
+		( /sbin/start-stop-daemon --start --quiet --exec $DAEMON )
 		RETVAL=$?
 		debian_end
 		;;
 	redhat)
-		if [ -f /etc/sysconfig/${NAME} ]; then
-                       . /etc/sysconfig/${NAME}
-                fi
 		echo -n $"Starting ${NAME}: "
-                if [ -n "$OPTIONS" ]; then
-                        daemon $DAEMON $OPTIONS
-                else
-                        daemon $DAEMON
-                fi
+		daemon $DAEMON
 		RETVAL=$?
 		[ $RETVAL -eq 0 ] && touch /var/lock/subsys/${NAME}
@@ -197,4 +172,10 @@
 		;;
 	esac
+	#
+	# The hiding kernel module
+	#
+	if [ $RETVAL -eq 0 ]; then
+		@sh_insmod_cmd@
+	fi
 	exit $RETVAL
 	;;
@@ -204,5 +185,5 @@
 	debian)
 		echo -n "Stopping $NAME"
-        	( /sbin/start-stop-daemon --stop --oknodo --quiet --exec $DAEMON )
+        	( /sbin/start-stop-daemon --stop --quiet --exec $DAEMON )
 		RETVAL=$? 
 		debian_end
Index: /trunk/rules.deb-light.in
===================================================================
--- /trunk/rules.deb-light.in	(revision 584)
+++ /trunk/rules.deb-light.in	(revision 1)
@@ -8,65 +8,88 @@
 #
 
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
-%:
-	dh $@ --with-autoreconf
+# This is the debhelper compatability version to use.
+export DH_COMPAT=1
+
+package=@install_name@
+
+# CAVEAT: including the --enable-base= option is for packages to be
+#         distributed INTERNALLY on your network, NOT for packages
+#         to be distributed to THIRD PARTIES
+
+build: build-stamp
+build-stamp:
+	dh_testdir
+	@top_srcdir@/configure @mydefargs@
+	$(MAKE) 
+	echo '#!/bin/sh' > ./sstrip
+	echo 'echo "*** SSTRIP DISABLED ***"' >> ./sstrip
+	touch build-stamp
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp
+	-[ -f Makefile ] && $(MAKE) distclean
+	dh_clean
+
+install: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k
+	dh_installdirs
+
+	$(MAKE) install-light install-boot DESTDIR=`pwd`/debian/tmp
+
+	# However, remove the rc.d links
+	-rm -rf `pwd`/debian/tmp/etc/rc?.d
+
+	# Remove samhain_stealth for light install
+	-rm -f `pwd`/debian/tmp/@sbindir@/@install_name@_stealth
+
+# Build architecture-independent files here.
+binary-indep: build install
+# We have nothing to do by default.
 
 
-override_dh_clean:
-	[ ! -f Makefile ] || $(MAKE) distclean
-	-rm -f samhainrc.install
-	-rm -f build-stamp build-server-stamp build-client-stamp
-	dh_clean
-
-override_dh_auto_configure:
-	@top_srcdir@/configure @mydefargs@
-
-override_dh_auto_build:
-	dh_auto_build
-	if ! test x$(PASSWORD) = x; then \
-		if test -f samhain_setpwd; then \
-			./samhain_setpwd samhain new $(PASSWORD); \
-			rm samhain; \
-			mv samhain.new samhain; \
-		fi; \
-	fi
-
-override_dh_auto_install:
-	$(MAKE) install-light install-boot DESTDIR=`pwd`/debian/@install_name@
+# Build architecture-dependent files here.
+binary-arch: build install
+#	dh_testversion
+	dh_testdir
+	dh_testroot
+	dh_installdebconf	
+	# dh_installdocs
+	dh_installmenu
+	dh_installinit -- defaults 19
+	[ -f debian/postinst.debhelper ] && \
+	        cd debian && \
+		cat postinst.debhelper | \
+		    sed 's%/etc/init.d/@install_name@ start%:%' > postinst.tmp && \
+		    mv postinst.tmp postinst.debhelper
+	[ -f debian/prerm.debhelper ] && \
+		cd debian && \
+		cat prerm.debhelper | \
+		    sed 's%/etc/init.d/@install_name@ stop%/etc/init.d/@install_name@ stop || echo service @install_name@ already stopped%' > prerm.tmp && \
+		    mv prerm.tmp prerm.debhelper
+	# dh_installmanpages
+	# dh_installchangelogs @top_srcdir@/docs/Changelog
+	dh_link
+	# dh_strip
+	dh_compress
+	dh_fixperms
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
 
 
-override_dh_install:
-	# However, remove the rc.d links
-	-rm -rf `pwd`/debian/@install_name@/etc/rc?.d
-	# Remove samhain_stealth for light install
-	-rm -f `pwd`/debian/@install_name@/@sbindir@/@install_name@_stealth
-	# remove samhain_setpwd if not needed
-	if ! test x$(PASSWORD) = x; then \
-		rm -f `pwd`/debian/@install_name@/@sbindir@/@install_name@_setpwd; \
-	fi
+define checkdir
+	test -f debian/rules
+endef
 
-override_dh_installdocs:
-	# do nothing
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install
 
-override_dh_installchangelogs:
-	# do nothing
-
-override_dh_installman:
-	# do nothing
-
-override_dh_installinit:
-	dh_installinit --no-start -- defaults 19
-
-override_dh_usrlocal:
-	# do nothing
-
-override_dh_fixperms:
-	dh_fixperms
-	# Fix the permissions
-	chmod o-rX `pwd`/debian/@install_name@/@mydataroot@ \
-		`pwd`/debian/@install_name@/@myrpmconffile@
-	if ! test "x@mylogdir@" = "x/var/log"; then \
-		chmod o-rX `pwd`/debian/@install_name@/@mylogdir@; \
-	fi
-
-
Index: /trunk/rules.deb.in
===================================================================
--- /trunk/rules.deb.in	(revision 584)
+++ /trunk/rules.deb.in	(revision 1)
@@ -8,59 +8,109 @@
 #
 
-%:
-	dh $@ --with-autoreconf
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
-override_dh_clean:
-	[ ! -f Makefile ] || $(MAKE) distclean
-	-rm -f samhainrc.install
-	-rm -f build-stamp build-server-stamp build-client-stamp
+# This is the debhelper compatability version to use.
+export DH_COMPAT=1
+
+package=@install_name@
+
+# CAVEAT: including the --enable-base= option is for packages to be
+#         distributed INTERNALLY on your network, NOT for packages
+#         to be distributed to THIRD PARTIES
+
+build: build-stamp
+build-stamp:
+	dh_testdir
+	@top_srcdir@/configure @mydefargs@
+	$(MAKE) 
+	# echo '#!/bin/sh' > ./sstrip
+	# echo 'echo "*** SSTRIP DISABLED ***"' >> ./sstrip
+	touch build-stamp
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp
+	-[ -f Makefile ] && $(MAKE) distclean
 	dh_clean
 
-override_dh_auto_configure:
-	@top_srcdir@/configure @mydefargs@
+install: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k
+	dh_installdirs
 
-override_dh_auto_build:
-	dh_auto_build
-	if ! test x$(PASSWORD) = x; then \
-		if test -f samhain_setpwd; then \
-			./samhain_setpwd samhain new $(PASSWORD); \
-			rm samhain; \
-			mv samhain.new samhain; \
-		fi; \
-	fi
+	# Fix the permissions
+	#chmod o-rX `pwd`/debian/tmp/var/log/samhain \
+	#	`pwd`/debian/tmp/var/run/samhain \
+	#	`pwd`/debian/tmp/var/state/samhain \
+	#	`pwd`/debian/tmp/etc/samhain
 
-override_dh_auto_install:
-	$(MAKE) install install-boot DESTDIR=`pwd`/debian/@install_name@
+	$(MAKE) install install-boot DESTDIR=`pwd`/debian/tmp
 
-override_dh_install:
 	# However, remove the rc.d links
-	-rm -rf `pwd`/debian/@install_name@/etc/rc?.d
+	-rm -rf `pwd`/debian/tmp/etc/rc?.d
 
-override_dh_installdocs:
-	dh_installdocs
-	[ -f debian/@install_name@/usr/share/doc/@install_name@/MANUAL-2_4.html.tar ] && \
-		cd debian/@install_name@/usr/share/doc/@install_name@ && \
-		tar xf MANUAL-2_4.html.tar && mv MANUAL-2_4 manual.html && \
-		rm -f MANUAL-2_4.html.tar
-	[ -f debian/@install_name@/usr/share/doc/@install_name@/MANUAL-2_4.pdf ] && \
-		cd debian/@install_name@/usr/share/doc/@install_name@ && \
-		mv MANUAL-2_4.pdf manual.pdf
+	# install -m 755 encode `pwd`/debian/tmp/usr/bin/samhain_encode
 
-override_dh_installchangelogs:
-	dh_installchangelogs docs/Changelog
+	# install -m 644 profiles/debianlinux_i386/samhainrc `pwd`/debian/tmp@myconffile@
+	# install -m 644 debian/samhain.logrotate `pwd`/debian/tmp/etc/logrotate.d/samhain
 
-override_dh_installinit:
-	dh_installinit --no-start -- defaults 19
+# Build architecture-independent files here.
+binary-indep: build install
+# We have nothing to do by default.
 
-override_dh_usrlocal:
-	# do nothing
 
-override_dh_fixperms:
+# Build architecture-dependent files here.
+binary-arch: build install
+#	dh_testversion
+	dh_testdir
+	dh_testroot
+	dh_installdebconf	
+	dh_installdocs 
+	[ -f debian/tmp/usr/share/doc/@install_name@/MANUAL-2_0.html.tar ] && \
+		cd debian/tmp/usr/share/doc/@install_name@ && \
+		tar xf MANUAL-2_0.html.tar && mv MANUAL-2_0 manual.html && \
+		rm -f MANUAL-2_0.html.tar
+	dh_installexamples @top_srcdir@/scripts/example_pager.pl \
+		@top_srcdir@/scripts/example_sms.pl \
+		@top_srcdir@/scripts/report.pl \
+		@top_srcdir@/scripts/concat.pl \
+		@top_srcdir@/scripts/samhain.logrotator \
+		@top_srcdir@/scripts/samhainadmin.pl \
+		@top_srcdir@/scripts/check_samhain.pl \
+		@top_srcdir@/yulerc.template \
+		@top_srcdir@/samhainrc.linux
+	dh_installmenu
+	dh_installinit -- defaults 19
+	[ -f debian/postinst.debhelper ] && \
+	        cd debian && \
+		cat postinst.debhelper | \
+		    sed 's%/etc/init.d/@install_name@ start%:%' > postinst.tmp && \
+		    mv postinst.tmp postinst.debhelper
+	[ -f debian/prerm.debhelper ] && \
+		cd debian && \
+		cat prerm.debhelper | \
+		    sed 's%/etc/init.d/@install_name@ stop%/etc/init.d/@install_name@ stop || echo service @install_name@ already stopped%' > prerm.tmp && \
+		    mv prerm.tmp prerm.debhelper
+	# dh_installmanpages
+	dh_installchangelogs @top_srcdir@/docs/Changelog
+	dh_link
+	# dh_strip
+	dh_compress
 	dh_fixperms
-	# Fix the permissions
-	chmod o-rX `pwd`/debian/@install_name@/@mydataroot@ \
-		`pwd`/debian/@install_name@/@myrpmconffile@
-	if ! test "x@mylogdir@" = "x/var/log"; then \
-		chmod o-rX `pwd`/debian/@install_name@/@mylogdir@; \
-	fi
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
 
+
+define checkdir
+	test -f debian/rules
+endef
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install
+
